// kindlescreenthread.cpp
//
// Copyright (C) 2010, 2009 Griffin I'Net, Inc. (blog@griffin.net)
//
// This file is licensed under the LGPL version 2.1, the text of which should
// be in the LICENSE.txt file, or alternately at this location:
// http://www.gnu.org/licenses/old-licenses/lgpl-2.1.txt
//
// DISCLAIMER: This software is released AS-IS with ABSOLUTELY NO WARRANTY OF
// ANY KIND.  The use of this software indicates your knowledge and acceptance
// of this.

#include <fcntl.h>
#include <asm/types.h>
typedef __u8 u8;
#include <linux/einkfb.h>
#include <sys/ioctl.h>
#include "kindlescreen.h"
#include <QFile>

#include "kindlescreenthread.h"

KindleScreenThread::KindleScreenThread(KindleScreen* screen, QObject* parent) : QThread(parent)
{
    _screen = screen;
    _quit = false;
}

KindleScreenThread::~KindleScreenThread()
{
    quitNow();
}

void KindleScreenThread::quitNow()
{
    _quit = true;
    wait();
}

void KindleScreenThread::run()
{
    while(!_quit)
    {
        _screen->_mutex.lock();
        if (_screen->_dirty)
        {
            QRect r = _screen->_updateRect;
            _screen->_dirty = false;
            _screen->_mutex.unlock();
            update_area_t ua;
            ua.x1 = r.left();
            ua.y1 = r.top();
            ua.x2 = r.right() + 1;
            ua.y2 = r.bottom() + 1;
            ua.which_fx = fx_invert;
            ua.buffer = NULL;
            ioctl(_screen->_fbd, FBIO_EINK_UPDATE_DISPLAY_AREA, &ua);
        }
        else
        {
            _screen->_mutex.unlock();
        }

        msleep(50);
    }
}

