/*
 * Copyright (C) 2004-2010 Geometer Plus <contact@geometerplus.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include <ZLTextView.h>
#include <ZLBlockTreeView.h>
#include <ZLTextKind.h>
#include <ZLTextElement.h>
#include <ZLTextParagraph.h>
#include <ZLTextParagraphCursor.h>

#include "BookTextView.h"
#include "../bookmodel/FBTextKind.h"

#include "FBReader.h"
#include "NextHyperlinkAction.h"
#include "../library/Library.h"
#include "../libraryTree/LibraryView.h"

#include "../../../zlibrary/ui/src/qt4/application/ZLQtApplicationWindow.h"

NextHyperlinkAction::NextHyperlinkAction(){
}

bool NextHyperlinkAction::isEnabled() const {
	return true;
}

void NextHyperlinkAction::run() {
	int x0, y0, x1, y1 ;

	if(FBReader::Instance().mode() == FBReader::BOOK_TEXT_MODE){
		if (FBReader::Instance().bookTextView().nextHyperlink(&x0, &y0, &x1, &y1, false))
		{
			FBReader::Instance().markActiveHyperlink(x0, y0, x1, y1, true) ;
		}
	}else if(FBReader::Instance().mode() == FBReader::LIBRARY_MODE)
	{
		if (FBReader::Instance().libraryByAuthorView().nextHyperlink(&x0, &y0, &x1, &y1))
		{
			FBReader::Instance().markActiveHyperlink(x0, y0, x1, y1, false) ;
		}
		else
		{
			FBReader::Instance().unmarkActiveHyperlink() ;
		}
	}else if(FBReader::Instance().mode() == FBReader::CONTENTS_MODE)
	{
		if (!FBReader::Instance().contentsView().isEmpty())
		{
			if (FBReader::Instance().contentsView().nextHyperlink(&x0, &y0, &x1, &y1, true))
		{
				FBReader::Instance().markActiveHyperlink(x0, y0, x1, y1, true) ;
			}
		}
	}
}

PrevHyperlinkAction::PrevHyperlinkAction(){
}

bool PrevHyperlinkAction::isEnabled() const {
	return true;
}

void PrevHyperlinkAction::run() {
	int x0, y0, x1, y1 ;

	if(FBReader::Instance().mode() == FBReader::BOOK_TEXT_MODE){
		if (FBReader::Instance().bookTextView().previousHyperlink(&x0, &y0, &x1, &y1, false))
		{
			FBReader::Instance().markActiveHyperlink(x0, y0, x1, y1, true) ;
		}
	}else if(FBReader::Instance().mode() == FBReader::LIBRARY_MODE)
	{
		if (FBReader::Instance().libraryByAuthorView().prevHyperlink(&x0, &y0, &x1, &y1))
		{
			FBReader::Instance().markActiveHyperlink(x0, y0, x1, y1, false) ;
		}
		else
		{
			FBReader::Instance().unmarkActiveHyperlink() ;
		}
	}else if(FBReader::Instance().mode() == FBReader::CONTENTS_MODE)
	{
		if (!FBReader::Instance().contentsView().isEmpty())
		{
			if (FBReader::Instance().contentsView().previousHyperlink(&x0, &y0, &x1, &y1, true))
		{
				FBReader::Instance().markActiveHyperlink(x0, y0, x1, y1, true) ;
			}
		}
	}
}

	
