include $(ROOTDIR)/makefiles/arch/unix.mk

ifeq "$(INSTALLDIR)" ""
  INSTALLDIR=/usr
endif
IMAGEDIR = $(INSTALLDIR)/share/pixmaps
APPIMAGEDIR = $(INSTALLDIR)/share/pixmaps/%APPLICATION_NAME%

CC = gcc
AR = ar rsu
LD = g++

CFLAGS = -pipe -fno-exceptions -Wall -Wno-ctor-dtor-privacy -W -DLIBICONV_PLUG
LDFLAGS =

ZLSHARED=no

ifeq "$(QWS)" ""

ifeq "$(UI_TYPE)" "qt"
  MOC = moc-qt3
  QTINCLUDE = -I /usr/include/qt3
else
  MOC = /opt/qtsdk-2010.05/qt/bin/moc
  QTINCLUDE = -I /opt/qtsdk-2010.05/qt/include/
endif

GTKINCLUDE = $(shell pkg-config --cflags gtk+-2.0 libpng xft)

ifeq "$(UI_TYPE)" "qt"
  UILIBS = -lqt-mt
endif

ifeq "$(UI_TYPE)" "qt4"
   UILIBS = -lQtGui -lQtCore
  CFLAGS += -I/opt/qtsdk-2010.05/qt/include -L/opt/qtsdk-2010.05/qt/lib
  LDFLAGS += -L/opt/qtsdk-2010.05/qt/lib
endif

ifeq "$(UI_TYPE)" "gtk"
  UILIBS = $(shell pkg-config --libs gtk+-2.0) -lpng -ljpeg
endif

else
 ## -DQT_KEYPAD_NAVIGATION
  MOC = /opt/usr/local/bin/moc
  QTINCLUDE = -I /opt/usr/local/include
  UILIBS = -lQtGui -lQtCore
  CFLAGS += -I/opt/usr/local/include -DQWS -DQ_WS_QWS -L/opt/usr/local/lib
  LDFLAGS += -L/opt/usr/local/lib
endif

RM = rm -rvf
RM_QUIET = rm -rf
